{-# LANGUAGE OverloadedLists #-}
module TypesWorkshop.ValidationNel where

import Data.List.NonEmpty (NonEmpty (..))
import Data.Validation

type ValidationNel e = Validation (NonEmpty e)

problem :: e -> ValidationNel e a
problem e = Failure (e :| [])

instance Monad (ValidationNel e) where
    Failure e >>= _ = Failure e
    Success x >>= f = f x