plugins {
    alias(libs.plugins.kotlin.jvm)
    `java-library`
}

repositories {
    mavenCentral()
    // maven("https://dl.bintray.com/pika-lab/tuprolog/")
}

dependencies {
    implementation(kotlin("stdlib"))
    implementation(libs.arrow.atomic)
    implementation(libs.arrow.core)
    implementation(libs.parsus)
    // implementation(libs.tuprolog.unify)
    testImplementation(kotlin("test"))
}

java {
    toolchain {
        languageVersion = JavaLanguageVersion.of(11)
    }
}

tasks.named<Test>("test") {
    useJUnitPlatform()
}
